﻿
var map = null;
var mapDiv = null;
var mapLatDisplay = null;
var mapLongDisplay = null;
var mapXLatDisplay = null;
var mapYLongDisplay = null;
var mouseButtonIsDown = false;
var mouseMoved = false;

function GetMap() {
    map = new VEMap('pubMapDiv');
    map.LoadMap();
    map.SetDashboardSize(VEDashboardSize.Small);
    map.AttachEvent("ondoubleclick", mapDoubleClicked);
    map.AttachEvent("onclick", mapClicked);
    map.AttachEvent("onmousedown", mapMouseDown);
    map.AttachEvent("onmouseup", mapMouseUp);
    map.AttachEvent("onmousemove", mapMouseMove);
    getDisplayFields();
    SetZoom(16);
    SetInitialLocation();
}

function SetInitialLocation() {
    try {
        map.Find(null, 'BN2 9UE', null, null, null, null, null, null, false, true, LocFound);
    }
    catch (e) {
        alert(e.message);
    }
}

function getDisplayFields() {
    mapDiv = document.getElementById('pubMapDiv');
    mapLatDisplay = document.getElementById('pubMapLat');
    mapLongDisplay = document.getElementById('pubMapLong');
    mapXLatDisplay = document.getElementById('mapXLat');
    mapYLongDisplay = document.getElementById('mapYLong');
}

function LocFound() {
    var latLong = map.GetCenter();
    AddPin(latLong.Latitude, latLong.Longitude);
    document.getElementById('pubMapDiv').style.visibility = 'visible';
}

function AddPin(pubLat, pubLong) {
    var latLong = new VELatLong(pubLat, pubLong, null, null);
    map.AddPushpin(latLong);
}

function MoveMapTo(pubLat, pubLong) {
    var latLong = new VELatLong(pubLat, pubLong, null, null);
    map.PanToLatLong(latLong);
}

function SetZoom(zoomLevel) {
	map.SetZoomLevel(zoomLevel);
}

function mapDoubleClicked(evnt) {
    return true;
}

function mapMouseDown(evnt) {
    mouseButtonIsDown = true;
    mouseMoved = false;
}

function mapMouseUp(evnt) {
    mouseButtonIsDown = false;
}

function mapMouseMove(evnt) {
    mouseMoved = true;
}

function mapClicked(evnt) {
    if (!mouseMoved) {
        var latLong = updateDisplay(evnt);
        MoveMapTo(latLong.Latitude, latLong.Longitude);
        updateDisplay();
    }
}

//function updateDisplay(evnt) {
//    mapLatDisplay.innerHTML = map.GetCenter().Latitude;
//    mapLongDisplay.innerHTML = map.GetCenter().Longitude;
//    if (evnt) {
//        var latLong = pixelToLatLong(evnt);
//        mapXLatDisplay.innerHTML = latLong.Latitude;
//        mapYLongDisplay.innerHTML = latLong.Longitude;
//        return latLong;
//    }
//}

//function pixelToLatLong(evnt) {
//    var x = evnt.mapX;
//    var y = evnt.mapY;
//    pixel = new VEPixel(x, y);
//    return map.PixelToLatLong(pixel);
//}

//function onBrowserResize() {
//    var mapTop = mapDiv.top;
//    var mapHeight = window.document.body.clientHeight;
//}

function onSilverlightError(sender, args) {

    var appSource = "";
    if (sender != null && sender != 0) {
        appSource = sender.getHost().Source;
    } 
    var errorType = args.ErrorType;
    var iErrorCode = args.ErrorCode;
    
    var errMsg = "Unhandled Error in Silverlight 2 Application " +  appSource + "\n" ;

    errMsg += "Code: "+ iErrorCode + "    \n";
    errMsg += "Category: " + errorType + "       \n";
    errMsg += "Message: " + args.ErrorMessage + "     \n";

    if (errorType == "ParserError")
    {
        errMsg += "File: " + args.xamlFile + "     \n";
        errMsg += "Line: " + args.lineNumber + "     \n";
        errMsg += "Position: " + args.charPosition + "     \n";
    }
    else if (errorType == "RuntimeError")
    {           
        if (args.lineNumber != 0)
        {
            errMsg += "Line: " + args.lineNumber + "     \n";
            errMsg += "Position: " +  args.charPosition + "     \n";
        }
        errMsg += "MethodName: " + args.methodName + "     \n";
    }

    throw new Error(errMsg);
}